<?php

    /**
    * Slide Ads
    */
    
    final class pgSlideUpAds {
        var $cookie_name = "sua_cookie";
        var $cookies = array();
        
        var $options_name = "sua_options";
        
        var $options = array(
            "enabled"           => 1,  
            "settings_id"       => 0,  
            "delay"             => 3,
            "dismiss_interval"  => 240,
            
            "rules"             => "normal",
            "rule_data"         => array(
                "everynthday"       => 1,
                "everynthvisit"     => 3,
                "everynthvisitini"  => 5
            ),
            
            "use_template"      => 1,
            
            "background_color"  => "#CCCCCC",
            
            "template"          => "ebook",
            "template_variant"  => "blue", 
            
            "allow_remove"      => 1,
            
            "content_type"  => 'link',

            "link_code"  => null,
            
            "autoresponder_code"  => null,
            "parse_autoresponder_code"  => 1
        );
        
        var $statistics_name = "sua_statistics";  
        
        var $statistics = array(
            "view_count"    => 0,
            "hit_count"     => 0
        );
        
        function __construct() {
            $this->options["settings_id"] = time();
            
            $this->loadOptions();    
            $this->loadStatistics();
            $this->loadCookies();  
            
            add_action("init", array($this, "init"));  
        }
        
        function getInstance() {
            static $instance;
            
            if (!is_object($instance)) {
                $instance = new pgSlideUpAds();
            }
            
            return $instance;
        }
        
        function saveOptions() {
            update_option($this->options_name, $this->options);
        }
        
        function loadOptions() {
            $options = get_option($this->options_name);
            if (is_array($options)) {
                $this->options = array_merge($this->options, $options);  
            } else {
                $this->saveOptions();
            }
        }
        
        function saveStatistics() {
            // Theres a bug in the update_option, returns false after the first call.
            return update_option($this->statistics_name, $this->statistics);                
        }
        
        function loadStatistics() {
            $statistics = get_option($this->statistics_name);
            if (is_array($statistics)) {
                $this->statistics = array_merge($this->statistics, $statistics);    
                // Fix
                $this->statistics['hit_count'] = sua_get_hit_count();  
            } else {
                $this->saveStatistics();
            }
        }
        
        function saveCookies() {
            $expires = time() + (60 * 60 * 24 * 365); // Default 1 year.
             
            if ($this->options["rules"] == "everynthday") {
                $expires = time() + (60 * 60 * 24 * intval($this->options["rule_data"]["everynthday"])); 
            }                              
            
            $this->cookies["settings_id"] = $this->options["settings_id"];
            
            setcookie($this->cookie_name, "", -1); // Bug fix.
            setcookie($this->cookie_name, serialize($this->cookies), $expires, '/');
            $_COOKIE[$this->cookie_name] = serialize($this->cookies);
        }
        
        function loadCookies() {
            if (isset($_COOKIE[$this->cookie_name])) {
                /*$cookies = get_magic_quotes_gpc()
                    ? unserialize(stripslashes($_COOKIE[$this->cookie_name]))
                    : unserialize($_COOKIE[$this->cookie_name]);*/ 
                    
                $cookies = unserialize(stripslashes($_COOKIE[$this->cookie_name]));
                   
                if (is_array($cookies)) {
                    $this->cookies = $cookies;
                } 
            } 
        }
        
        function init() {
            if (is_admin()) {    
                add_action('admin_menu', array($this, 'addMenu')); 
                add_action('admin_init', array($this, 'registerSettings'));   
                wp_enqueue_script("sua-farbtastic", SUA_PLUGIN_URL."/thirdparty/farbtastic/farbtastic.js", array("jquery")); 
                wp_enqueue_script("sua-colorpicker", SUA_PLUGIN_URL."/scripts/jquery.colorpicker.js");
                wp_enqueue_script("sua-admin", SUA_PLUGIN_URL."/scripts/sua-admin.js", array("jquery"));     
                                                                                                            
                wp_enqueue_style("sua-farbtastic", SUA_PLUGIN_URL."/thirdparty/farbtastic/farbtastic.css"); 
                wp_enqueue_style("sua-colorpicker", SUA_PLUGIN_URL."/styles/jquery.colorpicker.css");       
            } else { 
                if ($this->options['enabled']) {
                    $show_sua = false;
                    
                    if (! isset($this->cookies["settings_id"]) || 
                        ! isset($this->cookies["visit_count"]) || 
                        $this->cookies["settings_id"] != $this->options["settings_id"]) {
                        $this->cookies["visit_count"] = 0;
                        $this->cookies["removed"] = 0;
                    }
                    
                    switch($this->options["rules"]) {
                        
                        case "everynthvisit":              
                            if (0 == intval($this->cookies["visit_count"]) % $this->options["rule_data"]["everynthvisit"]) {
                                $show_sua = true;
                            } 
                        break;
                        
                        case "everynthvisitini":
                           if (intval($this->cookies["visit_count"]) < 5) {
                               $show_sua = true;
                           } elseif (0 == (intval($this->cookies["visit_count"]) - $this->options["rule_data"]["everynthvisitini"] + 1) % $this->options["rule_data"]["everynthvisit"]) {
                               $show_sua = true;
                           } 
                        break;
                        
                        case "everynthday":
                            if ($this->cookies["visit_count"] == 0) {
                                $show_sua = true;
                            }    
                        break;
                        
                        case "normal":
                        default:
                            $show_sua = true;    
                        break;    
                    }
                    
                    if ($show_sua && 1 != intval($this->cookies['removed'])) {
                        add_action("wp_footer", array($this, "markUp"));
                                                                                            
                        $sua_config = array(
                            "ajaxurl" => admin_url('admin-ajax.php'), 
                            "nonce" => wp_create_nonce('sua_nonce'),
                            "delay" => intval($this->options['delay']) * 1000,
                            "dismiss_interval" => intval($this->options['dismiss_interval']) * 1000,
                            "animation_time" => 750
                        );
                            
                        wp_enqueue_style("sua-default", SUA_PLUGIN_URL."/styles/default.css");
                        wp_enqueue_style("sua-plain", SUA_PLUGIN_URL."/styles/style.css");
                        
                        if (1 == intval($this->options["use_template"])) {
                            wp_enqueue_style("sua-template", SUA_PLUGIN_URL."/templates/{$this->options["template"]}/{$this->options["template_variant"]}/style.css");
                        } else {
                            $sua_config["background_color"] = $this->options['background_color'];
                        }
                          
                        wp_enqueue_script('sua', SUA_PLUGIN_URL."/scripts/sua.js", array("jquery"));  
                        wp_localize_script('sua', 'sua_config', $sua_config);  
                        
                        $this->statistics['view_count'] += 1;
                        $this->saveStatistics();
                    }    
                    
                    $this->cookies["visit_count"] = intval($this->cookies["visit_count"]) + 1;
                    $this->saveCookies();
                }
            }
        }
        
        function markUp() {
            ?>
                <div class="sua-box visit-<?php echo $this->cookies["visit_count"]; ?>">
                    <div class="header">
                    </div>
                    <div class="sua-buttons">               
                        <div class="sua-button sua-close"><span class="sua-tooltip">Close</span></div>               
                        <?php if (0 < intval($this->options['dismiss_interval'])) : ?>  
                            <div class="sua-button sua-dismiss"><span class="sua-tooltip">Remind Me Later</span></div>
                        <?php endif; ?>
                        <?php if (1 == intval($this->options['allow_remove'])) : ?>   
                            <div class="sua-button sua-remove"><span class="sua-tooltip">Remove Ad Permanently</span></div>
                        <?php endif; ?>
                    </div>
                        <?php 
                            switch($this->options['content_type']) {
                                case 'link':
                                    echo '<p class="sua-content sua-link">'.$this->options['link_code'].'</p>'; 
                                break;
                                
                                case 'autoresponder':
                                    echo '<div class="sua-content sua-form">'.$this->options['autoresponder_code'].'</div>'; 
                                break;
                                
                                default:
                                    echo '<p class="sua-content sua-link">Please specify the type of content on the Slide Up Ads settings page.</p>';
                                break;
                            }
                        ?>
                </div>
            <?php
        }
        
        
        
        /**
        * Admin Area Pages
        */
        
        function addMenu() {
            add_menu_page(__('Settings'), __('Slide Up Ads'), 'manage_options', 'sua-handle', array($this, 'settingsPage'));
            add_submenu_page('sua-handle', __('Settings'), __('Settings'), 'manage_options', 'sua-handle', array($this, 'settingsPage'));
        /**
            add_submenu_page('sua-handle', 'Statistics', 'Statistics', 'manage_options', 'sua-statistics-handle', array($this, 'statisticsPage'));
        */
        }
        
        function registerSettings() {
            register_setting($this->options_name, $this->options_name, array($this, "settingsPageValidation"));     
            register_setting($this->statistics_name, $this->statistics_name, array($this, "statisticsPageValidation"));  
        }
        
        function statisticsPage() {   
            load_view('statistics-page', array('sua' => $this));                                        
        }
        
        function statisticsPageValidation($input) {
            $input['view_count'] = 0;
            $input['hit_count'] = 0;
            
            // Fix
            update_option('sua_hit_count', 0);
            
            return $input;
        }
        
        function settingsPage() {                                                                          
            $dir = SUA_PLUGIN_DIR . "/templates/";
            
            $templates = array();
            
            foreach (sua_list_dirs($dir) as $template) {
                $templates[$template] = sua_list_dirs("{$dir}{$template}/");
            }
            
            $sua_options = $this->options;
//            var_dump($sua_options);
            ?>
                <div class="wrap" id="sua-settings">
                    <h2>Settings</h2>
                    <form method="post" action="options.php">
                        <?php settings_fields('sua_options'); ?>
                        <table class="form-table">
                            <tr valign="top">
                                <th scope="row"><b>Enabled</b></th>
                                    <input type="hidden" name="sua_options[enabled]" value="0" />
                                    <td><label><input type="checkbox" name="sua_options[enabled]" value="1" <?php __checked_selected_helper('1', $sua_options['enabled'], true, 'checked');  ?> /></i></label>
                                </td>
                            </tr>
                            <tr valign="top">
                                <th scope="row"><b>Reset Viewers</b></th>
                                    <input type="hidden" name="sua_options[settings_id]" value="<?php echo $sua_options['settings_id']; ?>" />
                                    <td><label><input type="checkbox" name="sua_options[settings_id]" value="<?php echo time(); ?>" /> <i>Check this if you want to reset the rules to viewers.</i></label>
                                </td>
                            </tr>
                            <tr valign="top">
                                <th scope="row"><b>Slide Delay</b></th>
                                <td><input type="text" name="sua_options[delay]" value="<?php echo $sua_options['delay']; ?>" /> <i>Seconds</i></td>
                            </tr>
                            <tr valign="top">
                                <th scope="row"><b>Remind Me Later Time</b></th>
                                <td><input type="text" name="sua_options[dismiss_interval]" value="<?php echo $sua_options['dismiss_interval']; ?>" /> <i>Seconds</i></td>
                            </tr>
                            <tr valign="top">
                                <th scope="row"><b>Rules</b></th>
                                <td>
                                    <select id="rules" name="sua_options[rules]">
                                        <option value="normal"<?php __checked_selected_helper('normal', $sua_options['rules'], true, 'selected'); ?>>
                                            Normal
                                        </option>
                                        <option value="everynthvisit"<?php __checked_selected_helper('everynthvisit', $sua_options['rules'], true, 'selected'); ?>>
                                            Every nth view
                                        </option>
                                        <option value="everynthvisitini"<?php __checked_selected_helper('everynthvisitini', $sua_options['rules'], true, 'selected'); ?>>
                                            Every nth view with initial views
                                        </option>
                                        <option value="everynthday"<?php __checked_selected_helper('everynthday', $sua_options['rules'], true, 'selected'); ?>>
                                            Every nth day
                                        </option>
                                    </select>
                                </td>     
                            </tr>
                            <tr class="rule-data rule-data-everynthvisit rule-data-everynthvisitini" valign="top" style="display: none;">
                                <th scope="row"><b>Views</b></th>
                                <td>
                                    <input type="text" name="sua_options[rule_data][everynthvisit]" value="<?php echo $sua_options['rule_data']['everynthvisit']; ?>" /> 
                                </td>    
                            </tr>
                            <tr class="rule-data rule-data-everynthvisitini" valign="top" style="display: none;">
                                <th scope="row"><b>Initial Views</b></th>
                                <td>
                                    <input type="text" name="sua_options[rule_data][everynthvisitini]" value="<?php echo $sua_options['rule_data']['everynthvisitini']; ?>" /> 
                                </td>     
                            </tr>
                            <tr class="rule-data rule-data-everynthday" valign="top" style="display: none;">
                                <th scope="row"><b>Days</b></th>
                                <td>
                                    <input type="text" name="sua_options[rule_data][everynthday]" value="<?php echo $sua_options['rule_data']['everynthday']; ?>" /> 
                                </td>     
                            </tr>
                            <tr valign="top">
                                <th scope="row"><b>Allow Remove</b></th>
                                <td>
                                    <input type="hidden" name="sua_options[allow_remove]" value="0" /> 
                                    <label><input id="allow_remove" type="checkbox" name="sua_options[allow_remove]" value="1" <?php echo intval($sua_options['allow_remove']) == 1 ? 'checked="checked" ' : ''; ?>/> 
                                    <i>Add a remove button to your ad.</i></label>
                                </td>     
                            </tr>
                            <tr valign="top">
                                <th scope="row"><b>Use Template</b></th>
                                <td>
                                    <input type="hidden" name="sua_options[use_template]" value="0" /> 
                                    <label><input id="use_template" type="checkbox" name="sua_options[use_template]" value="1" <?php echo intval($sua_options['use_template']) == 1 ? 'checked="checked" ' : ''; ?>/> 
                                    <i>Use a predefined template.</i></label>
                                </td>     
                            </tr>
                            <tr class="template-option" valign="top">
                                <th scope="row"><b>Background Color</b></th>
                                <td>
                                    <input class="color-picker" type="text" name="sua_options[background_color]" value="<?php echo $this->options['background_color']; ?>" />
                                </td>
                            </tr>
                            <tr class="template-option-checked" valign="top">
                                <th scope="row"><b>Template</b></th>
                                <td>
                                    <select id="template" name="sua_options[template]">
                                        <?php foreach (array_keys($templates) as $template) : ?>
                                            <option value="<?php echo $template; ?>"<?php echo ($template == $sua_options["template"]) ? 'selected="selected" ' : ""; ?>>
                                                <?php echo ucwords($template); ?>
                                            </option>
                                        <?php endforeach; ?>
                                    </select>
                                </td>
                            </tr>
                            <tr class="template-option-checked" valign="top">
                                <th scope="row"><b>Template Variant</b></th>
                                <td>
                                    <?php foreach ($templates as $f => $v) : ?>
                                        <select name="sua_options[template_variant]"class="sua_options_template_variant" id="<?php echo $f ?>-variants"<?php echo ($f != $sua_options["template"]) ? ' style="display: none;" disabled="disabled"' : ""; ?>>
                                            <?php foreach ($v as $variant) : ?>
                                                <option value="<?php echo $variant; ?>"<?php echo (($f == $sua_options["template"]) && ($variant == $sua_options["template_variant"])) ? ' selected="selected"' : ""; ?>>
                                                    <?php echo ucwords($variant); ?>
                                                </option>
                                            <?php endforeach; ?>
                                        </select>
                                    <?php endforeach; ?>
                                </td>
                            </tr>           
                            <tr valign="top">
                                <th scope="row"><b>Content Type</b></th>
                                <td>
                                    <select id="content-type" name="sua_options[content_type]">
                                        <option value="link"<?php __checked_selected_helper('link', $sua_options['content_type'], true, 'selected'); ?>>
                                            Link
                                        </option>
                                        <option value="autoresponder"<?php __checked_selected_helper('autoresponder', $sua_options['content_type'], true, 'selected'); ?>>
                                            Autoresponder
                                        </option>
                                    </select>
                                </td>     
                            </tr>                            
                            <tr valign="top" class="content-type-data content-type-data-link">
                                <th scope="row"><b>Link Code</b></th>
                                <td>  
                                    <textarea cols="100" rows="10" name="sua_options[link_code]"><?php echo $sua_options['link_code']; ?></textarea><br />
                                </td>
                            </tr>                            
                            <tr valign="top" class="content-type-data content-type-data-autoresponder">
                                <th scope="row"><b>Autoresponder Code</b></th>
                                <td>  
                                    <textarea cols="100" rows="10" name="sua_options[autoresponder_code]"><?php echo $sua_options['autoresponder_code']; ?></textarea><br />
                                    <input type="hidden" name="sua_options[parse_autoresponder_code]" value="0" />
                                    <label><input type="checkbox" name="sua_options[parse_autoresponder_code]" value="1" <?php __checked_selected_helper('1', $sua_options['parse_autoresponder_code'], true, 'checked');  ?> /> Parse autoresponder code.</label>
                                </td>
                            </tr>          
                        </table>
                        <p class="submit">
                            <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
                        </p>
                    </form>
                </div>
            <?php
        }
    
       function settingsPageValidation($input) {
            $input["settings_id"] = intval($input["settings_id"]);
            $input["delay"] = intval($input["delay"]);           
            $input["dismiss_interval"] = intval($input["dismiss_interval"]);           
            $input["rules"] = trim($input["rules"]);
            $input['rule_data']['everynthvisit'] = intval($input['rule_data']['everynthvisit']);
            $input['rule_data']['everynthvisitini'] = intval($input['rule_data']['everynthvisitini']);
            $input['rule_data']['everynthday'] = intval($input['rule_data']['everynthday']);
            $input["use_template"] = intval($input["use_template"]);
//            $input["background_color"] = trim($input["background_color"]);
            $input["template"] = trim($input["template"]);
            $input["template_variant"] = trim($input["template_variant"]);
            $input["parse_autoresponder_code"] = intval($input['parse_autoresponder_code']);
            
            if (1 == $input["parse_autoresponder_code"]) {
                $input["autoresponder_code"] = sua_parse_autoresponder_code($input["autoresponder_code"]);    
            }
            
            return $input;
       }
        
        
        /**
        * Ajax functions
        */
        
        function ajaxCounterCb() {       
//            $nonce = $_POST['nonce'];
//            if (! wp_verify_nonce( $nonce, 'sua_nonce'))
//                die( 'Busted!');
//            
//            $this->statistics['hit_count'] = intval($this->statistics['hit_count']) + 1;            
//            $this->saveStatistics();

//            echo json_encode(is_admin());
//            echo json_encode($this->saveStatistics());
//            die();
        }
        
        function ajaxUtilCb() {       
            switch($_POST['func']) {
                case 'remove':            
                    $this->cookies['removed'] = 1;
                    $this->saveCookies(); 
                break;
            }
            die();
        }
    }
?>
