<?php
  
    function sua_parse_autoresponder_code($html_code) {
        require_once("thirdparty/simplehtmldom/simple_html_dom.php");
        
        $html = new simple_html_dom();
        $html->load($html_code);
        
        $form = $html->find("form", 0);
        
        if (isset($form)) {
            $inputs = $form->find("input");
            
            $form_code = "<form action=\"{$form->action}\" method=\"{$form->method}\" enctype=\"{$form->enctype}\">\r\n";
            
            foreach ($inputs as $input) {
                if ("hidden" != $input->type && "button" != $input->type && "submit" != $input->type) {
                    if (null == $input->id) {
                        $input->id = $input->name."_id";
                    }
                    
                    $label = $form->find("label[for={$input->id}]", 0);
                    
                    if (isset($label)) {
                        $form_code .= $label->outertext;    
                    } else {
                        $form_code .= '<label for="'.$input->id.'">'. ucfirst($input->name) . ":</label>";
                    }
                    
                    $form_code .= "{$input->outertext}\r\n";    
                } else {
                    $form_code .= "{$input->outertext}\r\n";     
                }
            }
            
            $form_code .= "</form>";
            
            return $form_code;
        } else {
            return null;
        }
    }
    
    function sua_list_dirs($dir) {
        if (is_dir($dir)) {
            if ($dh = opendir($dir)) {
                $dirs = array();
                
                while (($file = readdir($dh)) !== false) {
                    if (!in_array($file, array(".", ".."))) {
                        if (is_dir($dir.$file)) {
                            $dirs[] = $file;
                        }               
                    }
                }
                
                closedir($dh);
                sort($dirs);
                return $dirs;
            }
            
            return false;
        } else {
            return false;
        }
    }
    
    function ajaxCounterCb() {
        $nonce = $_POST['nonce'];
        if (! wp_verify_nonce( $nonce, 'sua_nonce'))
            die('Busted!');
        
        $on = "sua_hit_count";
        $v = get_option($on);
        $v = intval($v) + 1;
        update_option($on, $v);
        die();
    } 
    
    function sua_get_hit_count() {
        $on = "sua_hit_count";
        $v = get_option($on);
        return intval($v);
    }
    
    function load_view($name, $data) {
        foreach ($data as $f => $v) {
            $$f = $v;
        }
        
        include(SUA_PLUGIN_DIR."/views/{$name}.php");
    }
?>
